use std::io::{BufRead, BufReader};
use std::fs::File;
use std::collections::HashMap;

fn main (){
    // let filename = "../1/input_example.txt";
    let filename = "../1/input.txt";
    let file = BufReader::new(File::open(filename).expect("Unable to open file"));
    let mut accum: u32 = 0;

    let mut list1: Vec<u32> = vec![];
    let mut counters: HashMap<u32, u32> = HashMap::new();

    for line in file.lines() { 
        let wline = line.unwrap();
        let nums: Vec<&str> = wline.split(' ')
            .filter(|&x| !x.is_empty())
            .collect();

        list1.push(nums[0].parse().unwrap());

        counters.entry(nums[1].parse().unwrap())
            .and_modify(|e| {*e += 1})
            .or_insert(1);
    }

    for n in list1 {
        if counters.contains_key(&n){
            accum += n * counters[&n];
        }
    }

    println!("{}", accum);
}
